/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.9 Professional

Project : 
Version : 
Date    : 01.03.2011
Author  : Halex                           
Company : Home                            
Comments: 


Chip type           : ATmega8
Program type        : Application
Clock frequency     : 4,096 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

#include <mega8.h>

//       
//    FLASH-   
flash char  simbol[]={ 
0xC0, //0
0xF9, //1
0xA4, //2
0xB0, //3
0x99, //4
0x92, //5
0x82, //6
0xF8, //7
0x80, //8
0x90, //9
0x88, //A
0x83,  //b
0xC6, //C
0xA1, //d
0x86, //E
0x8E, //F
0xBF, // "-"
0xFF  //
};       
//  
//  4     
//(    5 -     )
//                           |
//                           V
unsigned char out_digit[5]= {0, 1, 2, 3, 4};
volatile unsigned char dig_pointer=1; //   
//    Timer 0 
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
PORTB =  0xFF; // 
//   
if((PORTD == 0x00)||(PORTD == 0x08))
PORTD = 0x01;
else
PORTD=PORTD<<1;
//  
PORTB = simbol[out_digit[dig_pointer]];
//      
if (dig_pointer == 3) 
PORTB &= 0x7F;
dig_pointer++; //    

if (dig_pointer == 5) 
dig_pointer = 1;
}



void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
//  Port B  -      1 
PORTB=0xFF; 
DDRB=0xFF;
//  Port C  -    
PORTC=0x00;
DDRC=0x00;
//  Port B  -   
PORTD=0x00;
DDRD=0xFF;
// Clock source: System Clock
// Clock value: 64,000 kHz
TCCR0=0x03;
TCNT0=0x00;
// Timer/Counter 1  
TCCR1A=TCCR1B=TCNT1H=TCNT1L=ICR1H=ICR1L=OCR1AH=OCR1AL=OCR1BH=OCR1BL=0;
// Timer/Counter 1  
ASSR=TCCR2=TCNT2=OCR2=0;
//   
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x01;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// Global enable interrupts
#asm("sei")

while (1)
      {
      // Place your code here

      };
}
