/*****************************************************
This program was produced by the
CodeWizardAVR V2.05.0 Professional

Chip type               : ATmega8
Program type            : Application
AVR Core Clock frequency: 6,553600 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*****************************************************/

#include <mega8.h>
 //       
//    FLASH-
flash char  simbol[]={
0xC0, //0
0xF9, //1
0xA4, //2
0xB0, //3
0x99, //4
0x92, //5
0x82, //6
0xF8, //7
0x80, //8
0x90, //9
0x88, //A
0x83,  //b
0xC6, //C
0xA1, //d
0x86, //E
0x8E, //F
0xBF, // "-"
0xFF  //
};
//  
//  4    (    )
unsigned char out_digit[5]= {0, 1, 2, 3, 4};
 volatile unsigned char dig_pointer=1;  //    
//    Timer 0
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
//PORTD =  0xFF; // 
//   
if((PORTB == 0x00)||(PORTB == 0x08))
PORTB = 0x01;
else
PORTB=PORTB<<1;
//  
PORTD = simbol[out_digit[dig_pointer]];
//      
if (dig_pointer == 3)
PORTD &= 0x7F;
dig_pointer++; //    

if (dig_pointer == 5)
dig_pointer = 1;

}

// Declare your global variables here

void main(void)
{
// Declare your local variables here

//  Port B  -      0 
PORTB=0x00;
DDRB=0xFF;

//  Port C -   
PORTC=0x00;
DDRC=0x00;

//  Port C  -      1 
PORTD=0xFF;
DDRD=0xFF;

// Timer/Counter 0 initial
// Clock source: System Clock
// Clock value: 25,600 kHz
TCCR0=0x04;
TCNT0=0x00;

// Timer/Counter 1 
TCCR1A=TCCR1B=TCNT1H=TCNT1L=0x00;
ICR1H=ICR1L=OCR1AH=OCR1AL=OCR1BH=OCR1BL=0x00;
// Timer/Counter 2 

ASSR=TCCR2=TCNT2=OCR2=0x00;

//   
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x01;

// USART initialization
// USART disabled
UCSRB=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// ADC initialization
// ADC disabled
ADCSRA=0x00;

// SPI initialization
// SPI disabled
SPCR=0x00;

// TWI initialization
// TWI disabled
TWCR=0x00;

// Global enable interrupts
#asm("sei")

while (1)
      {
      // Place your code here

      }
}
