#include "main_4.h"
/* =============== : =============== */
unsigned int8 dig_pointer; //  
/*                   V--------V  --->         */
char dig_array[]={0, 1, 2, 3, 4}; //     
/* =============== : =============== */
const char digits=4; //  
const char  simbol[]={ //    
0xC0, //0
0xF9, //1
0xA4, //2
0xB0, //3
0x99, //4
0x92, //5
0x82, //6
0xF8, //7
0x80, //8
0x90, //9
0xBF, // "-"
0xFF  //
}; 

/* ===============    0 =============== */
#int_timer0
void timer0_isr(void)
{
output_B(0xFF); // B -  
output_C(0x01<<dig_pointer); // 1    
dig_pointer++; //  
      if (dig_pointer > digits)
      dig_pointer=0; //     
output_B(simbol[dig_array[dig_pointer]]); // B -  
}

/* ===============    =============== */
void main()
{
//  
   setup_adc_ports(NO_ANALOGS);
   setup_adc(ADC_CLOCK_DIV_2);
   setup_spi(SPI_SS_DISABLED);
   setup_timer_0(RTCC_INTERNAL|RTCC_DIV_4); //  - 1 
   setup_timer_1(T1_DISABLED);
   setup_timer_2(T2_DISABLED,0,1);
   setup_ccp1(CCP_OFF);
   setup_comparator(NC_NC_NC_NC);
   setup_vref(FALSE);

output_B(0xFF); // B -  
output_C(0x00); //  -  

enable_interrupts(INT_TIMER0); //    0
enable_interrupts(GLOBAL);     //  

while(TRUE); // 

}
